<?php 

ob_start();
session_start();

?>
<?php
// Tell PayFast that this page is reachable by triggering a header 200
header( 'HTTP/1.0 200 OK' );
flush();

define( 'SANDBOX_MODE', true );
$pfHost = SANDBOX_MODE ? 'sandbox.payfast.co.za' : 'www.payfast.co.za';
// Posted variables from ITN
$pfData = $_POST;

// Strip any slashes in data
foreach( $pfData as $key => $val ) {
    $pfData[$key] = stripslashes( $val );
}

// Convert posted variables to a string
foreach( $pfData as $key => $val ) {
    if( $key !== 'signature' ) {
        $pfParamString .= $key .'='. urlencode( $val ) .'&';
    } else {
        break;
    }
}

$pfParamString = substr( $pfParamString, 0, -1 );


function pfValidSignature( $pfData, $pfParamString, $pfPassphrase = null ) {
    // Calculate security signature
    if($pfPassphrase === null) {
        $tempParamString = $pfParamString;
    } else {
        $tempParamString = $pfParamString.'&passphrase='.urlencode( $pfPassphrase );
    }

    $signature = md5( $tempParamString );
    return ( $pfData['signature'] === $signature );
}


function pfValidIP() {
    // Variable initialization
    $validHosts = array(
        'www.payfast.co.za',
        'sandbox.payfast.co.za',
        'w1w.payfast.co.za',
        'w2w.payfast.co.za',
        );

    $validIps = [];

    foreach( $validHosts as $pfHostname ) {
        $ips = gethostbynamel( $pfHostname );

        if( $ips !== false )
            $validIps = array_merge( $validIps, $ips );
    }

    // Remove duplicates
    $validIps = array_unique( $validIps );
    $referrerIp = gethostbyname(parse_url($_SERVER['HTTP_REFERER'])['host']);
    if( in_array( $referrerIp, $validIps, true ) ) {
        return true;
    }
    return false;
}


function pfValidPaymentData( $cartTotal, $pfData ) {
    return !(abs((float)$cartTotal - (float)$pfData['amount_gross']) > 0.01);
}


function pfValidServerConfirmation( $pfParamString, $pfHost = 'sandbox.payfast.co.za', $pfProxy = null ) {
    // Use cURL (if available)
    if( in_array( 'curl', get_loaded_extensions(), true ) ) {
        // Variable initialization
        $url = 'https://'. $pfHost .'/eng/query/validate';

        // Create default cURL object
        $ch = curl_init();
    
        // Set cURL options - Use curl_setopt for greater PHP compatibility
        // Base settings
        curl_setopt( $ch, CURLOPT_USERAGENT, NULL );  // Set user agent
        curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );      // Return output as string rather than outputting it
        curl_setopt( $ch, CURLOPT_HEADER, false );             // Don't include header in output
        curl_setopt( $ch, CURLOPT_SSL_VERIFYHOST, 2 );
        curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, true );
        
        // Standard settings
        curl_setopt( $ch, CURLOPT_URL, $url );
        curl_setopt( $ch, CURLOPT_POST, true );
        curl_setopt( $ch, CURLOPT_POSTFIELDS, $pfParamString );
        if( !empty( $pfProxy ) )
            curl_setopt( $ch, CURLOPT_PROXY, $pfProxy );
    
        // Execute cURL
        $response = curl_exec( $ch );
        curl_close( $ch );
        if ($response === 'VALID') {
            return true;
        }
    }
    return false;
}

//$myfile = fopen("newfile.txt", "w") or die("Unable to open file!");



$check1 = pfValidSignature($pfData, $pfParamString);
$check2 = pfValidIP();
$check3 = pfValidPaymentData($cartTotal, $pfData);
$check4 = pfValidServerConfirmation($pfParamString, $pfHost);






// fwrite($myfile, 'm_payment_id:'.$pfData['m_payment_id']."\n");
// fwrite($myfile, 'pf_payment_id:'.$pfData['pf_payment_id']."\n");
// fwrite($myfile, 'payment_status:'.$pfData['payment_status']."\n");
// fwrite($myfile, 'item_name:'.$pfData['item_name']."\n");
// fwrite($myfile, 'amount_gross:'.$pfData['amount_gross']."\n");
// fwrite($myfile, 'amount_fee:'.$pfData['amount_fee']."\n");
// fwrite($myfile, 'merchant_id:'.$pfData['merchant_id']."\n");
// fwrite($myfile, 'signature:'.$pfData['signature']."\n");
// fwrite($myfile, 'name_first:'.$pfData['name_first']."\n");
// fwrite($myfile, 'email_address:'.$pfData['email_address']."\n");



// fclose($myfile);

if($check1 && $check2 && $check3 && $check4) {
    // All checks have passed, the payment is successful
    // print_r($response);
    // echo "hi";exit;
} else {
    // Some checks have failed, check payment manually and log for investigation
} 


$sta = explode("-",$pfData['m_payment_id']);
$webid = $sta[0];
$userid = $sta[1];
$status = 'Completed';

// echo $userid;exit();
// exit();
if($userid)
{
    //echo "sss";exit();
	$handle = curl_init();
	$url = "https://app.softsites.org/site/placeorder.php";
	curl_setopt($handle, CURLOPT_URL, $url);
	curl_setopt($handle, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($handle, CURLOPT_CUSTOMREQUEST, 'POST');
	curl_setopt($handle, CURLOPT_SSL_VERIFYPEER, false );
	curl_setopt($handle, CURLOPT_POSTFIELDS, 'webid='.$webid.'&userid='.$userid.'&status='.$status.'');
	$output = curl_exec($handle);
	curl_close($handle);
	
	//print_r($output);
}


// header('Location: thankyou.php');


// $ITN_Payload = [
//  'm_payment_id' => 'SuperUnique1',
//  'pf_payment_id' => '1089250',
//  'payment_status' => 'COMPLETE',
//  'item_name' => 'test+product',
//  'item_description' => ,
//  'amount_gross' => 200.00,
//  'amount_fee' => -4.60,
//  'amount_net' => 195.40,
//  'custom_str1' => ,
//  'custom_str2' => ,
//  'custom_str3' => ,
//  'custom_str4' => ,
//  'custom_str5' => ,
//  'custom_int1' => ,
//  'custom_int2' => ,
//  'custom_int3' => ,
//  'custom_int4' => ,
//  'custom_int5' => ,
//  'name_first' => ,
//  'name_last' => ,
//  'email_address' => ,
//  'merchant_id' => '10012577',
//  'signature' => 'ad8e7685c9522c24365d7ccea8cb3db7'
// ]; 